SystemOrganization addCategory: #'Spec-Tasting'!

ComposablePresenter subclass: #ProtocolMethodList
	instanceVariableNames: 'label methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tasting'!

!ProtocolMethodList class methodsFor: 'specs' stamp: 'wfgd 12/18/2018 14:45'!
defaultSpec
^SpecColumnLayout composed 
add:#label height:self toolbarHeight ;
add:#methods;
yourself .! !

!ProtocolMethodList methodsFor: 'initialization' stamp: 'wfgd 12/18/2018 14:31'!
initializeWidgets
label:=self newLabel .
label label: 'Protocol'.
methods :=self newList .
methods displayBlock: [ :m|m selector].
self focusOrder add: methods .! !

!ProtocolMethodList methodsFor: 'api' stamp: 'wfgd 12/18/2018 14:35'!
items: aCollection
methods items:aCollection ! !

!ProtocolMethodList methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 14:45'!
label
	^ label! !

!ProtocolMethodList methodsFor: 'api' stamp: 'wfgd 12/18/2018 14:36'!
label:aText
label label: aText ! !

!ProtocolMethodList methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 14:45'!
methods
	^ methods! !

!ProtocolMethodList methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 14:45'!
methods: anObject
	methods := anObject! !

!ProtocolMethodList methodsFor: 'api' stamp: 'wfgd 12/18/2018 14:36'!
resetSelection 
methods resetSelection .! !

!ProtocolMethodList methodsFor: 'initialization' stamp: 'wfgd 12/18/2018 14:32'!
title 
^'Protocol widget'! !

ComposablePresenter subclass: #ProtocolViewer
	instanceVariableNames: 'models api events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tasting'!

!ProtocolViewer class methodsFor: 'specs' stamp: 'wfgd 12/18/2018 15:11'!
defaultSpec
^SpecColumnLayout composed 
add:#models; add:#api;add:#events;
yourself .! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 15:11'!
api
	^ api! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 15:11'!
api: anObject
	api := anObject! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 15:11'!
events
	^ events! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 15:11'!
events: anObject
	events := anObject! !

!ProtocolViewer methodsFor: 'initialization' stamp: 'wfgd 12/18/2018 15:26'!
initializePresenter 
models whenSelectedItemChanged: [ :class|
	api resetSelection .
	events resetSelection .
	class 
	ifNil: [api items: #(). events items: #()  ]
	ifNotNil: [ 
		api items: (self methodsIn:class for:'api').
		events items: (self methodsIn:class for:'api-events') ]
	
	  ].
api methods whenSelectedItemChanged: [ :method|
	method ifNotNil: [ events resetSelection  ] ].
events methods  whenSelectedItemChanged: [ api resetSelection  ].! !

!ProtocolViewer methodsFor: 'initialization' stamp: 'wfgd 12/18/2018 14:55'!
initializeWidgets
models:=self instantiate: WidgetClassList .
api:=self instantiate: ProtocolMethodList .
events:=self instantiate: ProtocolMethodList .

api label: 'api'.
events label: 'api-events'.
self focusOrder add: models; add:api;add:events.! !

!ProtocolViewer methodsFor: 'utilities' stamp: 'wfgd 12/18/2018 15:08'!
methodsIn:aClass for:protocol
^(aClass methodsInProtocol: protocol) sorted: [ :a :b| a selector<b selector].! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 15:11'!
models
	^ models! !

!ProtocolViewer methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 15:11'!
models: anObject
	models := anObject! !

!ProtocolViewer methodsFor: 'initialization' stamp: 'wfgd 12/18/2018 14:55'!
title 
^'Protocol viewer'.! !

!ProtocolViewer methodsFor: 'api' stamp: 'wfgd 12/18/2018 15:44'!
whenAPIChanged: aBlock
api whenSelectedItemChanged:aBlock.! !

!ProtocolViewer methodsFor: 'api' stamp: 'wfgd 12/18/2018 15:41'!
whenClassChanged: aBlock
models whenSelectedItemChanged: aBlock .! !

!ProtocolViewer methodsFor: 'api' stamp: 'wfgd 12/18/2018 15:43'!
whenEventChanged: aBlock
events whenSelectedItemChanged:aBlock.! !

ComposablePresenter subclass: #WidgetClassList
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tasting'!

!WidgetClassList class methodsFor: 'specs' stamp: 'wfgd 12/18/2018 14:25'!
defaultSpec
^ SpecLayout composed 
add: #list;
yourself .! !

!WidgetClassList methodsFor: 'initialization' stamp: 'wfgd 12/18/2018 14:23'!
initializeWidgets
list:=self newList .
list items: (AbstractWidgetPresenter allSubclasses sorted: [:a :b|a name <b name]).
self focusOrder add:list.! !

!WidgetClassList methodsFor: 'accessing' stamp: 'wfgd 12/18/2018 14:23'!
list
	^ list! !

!WidgetClassList methodsFor: 'api' stamp: 'wfgd 12/18/2018 14:24'!
title 
^'Widgets'! !

!WidgetClassList methodsFor: 'api' stamp: 'wfgd 12/18/2018 14:27'!
whenSelectedItemChanged: aBlock
list whenSelectedItemChanged: aBlock .! !
